jsasPlayerNamesTable = {} -- if a name appears here it hides
--creates a global table to save all the players names the addon sees

local function printd(...) --debug print function, call this or comment print out
    --print(...)
end


local function getCurrentFullname() -- returns players full name
    return UnitName("player") .. "-" .. GetRealmName()
end


local function getCurrentPlayerTable() -- Adds player to table if not seen before
    local jsasFullname = getCurrentFullname()
    if not jsasPlayerNamesTable[jsasFullname] then --if no entry matching player's full name exists THEN
      jsasPlayerNamesTable[jsasFullname] = {}
    end
    return jsasPlayerNamesTable[jsasFullname]
end

    
local function changeSpellAlerts(self, event, ...)
    if getCurrentPlayerTable()[GetSpecialization()] then
        printd("hiding")
        SetCVar("displaySpellActivationOverlays", 0)
    else
        printd("showing")
        SetCVar("displaySpellActivationOverlays", 1)
    end
end

local function printGreeting()
	print ("JSAS loaded. /jsas for options")
end

local function printUsage()
	print ("/jsas-hide /jsash or /jsh to hide alerts for current char/spec\n/jsas-show /jsass or /jss to show alerts for current char/spec")
end

local introText = CreateFrame("Frame")
introText:SetScript ("OnEvent", printGreeting)
introText:RegisterEvent("PLAYER_LOGIN")


local frame = CreateFrame("Frame","CVarSet")
frame:SetScript("OnEvent", changeSpellAlerts)
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")


local function hideHandler(msg, editBox)
    getCurrentPlayerTable()[GetSpecialization()] = true
    changeSpellAlerts()
	print("Now hiding alerts for ", getCurrentFullname(),"specialization ", GetSpecialization())
end

SLASH_JSAS_HIDE1 = '/jsas-hide'
SLASH_JSAS_HIDE2 = '/jsash'
SLASH_JSAS_HIDE3 = '/jsh'
SlashCmdList["JSAS_HIDE"] = hideHandler;


local function showHandler()
    printd("show", getCurrentFullname(), GetSpecialization())
    getCurrentPlayerTable()[GetSpecialization()] = false
    changeSpellAlerts()
	print("Now showing alerts for ", getCurrentFullname(),"specialization ", GetSpecialization())
    -- editBox:Hide()
end

SLASH_JSAS_SHOW1 = '/jsas-show'
SLASH_JSAS_SHOW2 = '/jsass'
SLASH_JSAS_SHOW3 = '/jss'
SlashCmdList["JSAS_SHOW"] = showHandler;

SLASH_JSAS_PRINT1 = '/jsas'
SlashCmdList["JSAS_PRINT"] = printUsage;
